<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="90px">
      <el-form-item label="疾病名称" prop="illnessName">
        <el-input
          v-model="queryParams.illnessName"
          placeholder="请输入疾病名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="方剂名称" prop="formulaName">
        <el-input
          v-model="queryParams.formulaName"
          placeholder="请输入方剂名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['his:illnessLibrary:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['his:illnessLibrary:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['his:illnessLibrary:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['his:illnessLibrary:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" border :data="illnessLibraryList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="疾病名称" align="center" prop="illnessName" />
     <el-table-column label="症状" align="center" prop="symptom" show-overflow-tooltip/>
      <el-table-column label="舌脉" align="center" prop="tongueVein" />
      <el-table-column label="治法" align="center" prop="therapy" />
      <el-table-column label="方剂名称" align="center" prop="formulaName" />
     <el-table-column label="方剂详情" align="center" prop="formulaDescs" show-overflow-tooltip />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['his:illnessLibrary:edit']"
          >修改</el-button>
          <el-button
              size="mini"
              type="text"
              @click="handledetails(scope.row)"
           >详情
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['his:illnessLibrary:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改中医疾病对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="疾病名称" prop="illnessName">
          <el-input v-model="form.illnessName" placeholder="请输入疾病名称" />
        </el-form-item>
        <el-form-item label="症状" prop="symptom" >
          <el-input v-model="form.symptom" placeholder="请输入症状" type="textarea" :rows="4"/>
        </el-form-item>
        <el-form-item label="舌脉" prop="tongueVein">
          <el-input v-model="form.tongueVein" placeholder="请输入舌脉" />
        </el-form-item>
        <el-form-item label="治法" prop="therapy">
          <el-input v-model="form.therapy" placeholder="请输入治法" />
        </el-form-item>
        <el-form-item label="方剂名称" prop="formulaName">
          <el-input v-model="form.formulaName" placeholder="请输入方剂名称" />
        </el-form-item>
        <el-form-item label="方剂详情" prop="formulaDescs">
          <el-input v-model="form.formulaDescs" type="textarea" placeholder="请输入内容" :rows="4"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <el-drawer
    	:with-header="false"
            size="75%"
             :title="show.title" :visible.sync="show.open">
         <IllnessLibraryDetails  ref="Details" />
       </el-drawer>



  </div>
</template>

<script>
import { listillnessLibrary, getillnessLibrary, delillnessLibrary, addillnessLibrary, updateillnessLibrary, exportillnessLibrary } from "@/api/his/illnessLibrary";
import IllnessLibraryDetails from '../../components/his/IllnessLibraryDetails.vue';
export default {
  name: "illnessLibrary",
  components: { IllnessLibraryDetails },
  data() {
    return {
      show:{
              open:false,
            },
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 中医疾病表格数据
      illnessLibraryList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        illnessName: null,
        formulaName: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        illnessName: [
          { required: true, message: "疾病名称不能为空", trigger: "blur" }
        ],
        symptom: [
          { required: true, message: "症状不能为空", trigger: "blur" }
        ],
        tongueVein: [
          { required: true, message: "舌脉不能为空", trigger: "blur" }
        ],
        therapy: [
          { required: true, message: "治法不能为空", trigger: "blur" }
        ],
        formulaName: [
          { required: true, message: "方剂名称不能为空", trigger: "blur" }
        ],
        formulaDescs: [
          { required: true, message: "方剂详情不能为空", trigger: "blur" }
        ]
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询中医疾病列表 */
    getList() {
      this.loading = true;
      listillnessLibrary(this.queryParams).then(response => {
        this.illnessLibraryList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        illnessId: null,
        illnessName: null,
        symptom: null,
        tongueVein: null,
        therapy: null,
        formulaName: null,
        formulaDescs: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.illnessId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加中医疾病";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const illnessId = row.illnessId || this.ids
      getillnessLibrary(illnessId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改中医疾病";
      });
    },
    handledetails(row){
            this.show.open=true;
            setTimeout(() => {
                 this.$refs.Details.getDetails(row.illnessId);
            }, 1);
        },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.illnessId != null) {
            updateillnessLibrary(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addillnessLibrary(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const illnessIds = row.illnessId || this.ids;
      this.$confirm('是否确认删除中医疾病编号为"' + illnessIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delillnessLibrary(illnessIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有中医疾病数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportillnessLibrary(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
